//+------------------------------------------------------------------+ 
//|   TRO_HHLL_LINES                                                 | 
//|                                                                  | 
//|   Copyright  2010, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2010, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window

extern bool   Show.ShadeHHLL    = true ; 
extern bool   Show.Open        = true ;
extern bool   Show.Boxes       = true ;  
extern bool   Show.Labels      = true ; 

extern int    ShiftLabel  =  7 ;


extern int myPeriod = 0 ;
extern int myShift  = 1 ;

extern int  iHHLLperiod       = 0;  
 
 
extern int  iHHLLstart        = 2; 
extern int  iHHLLend          = 14;  

extern int    Line_Style    = STYLE_DOT ;
extern int    Line_Width    = 1 ;
 

extern color  Line_Color_Open    = Orange ;   
extern color  Line_Color_HHLL     = Chocolate ;
extern color colorHHLLHighShade   = Navy  ;
extern color colorHHLLLowShade    = SkyBlue  ;


 


string lbl[15], lbl2[15];
int n, j, i ;

string symbol,  tChartPeriod, tHHLLPeriod, ShortName , TAG , text;  

int    digits, period, win, BarShift ; 

double point ;

double    HHprice, LLprice, TRIGGER, HHtrigger, LLtrigger, a_Open, W1_Open, W1_High, W1_Low,  a_pMid, a_Close ;
datetime DateTime ; 
   
double  W1_Close,W1_pivot,a_pivot, a_high, a_low , a_HH , a_LL , W1_HHLL, VALUE , D1Threshold , W1Threshold, HHLLThreshold ;      
double  W1_Close1, W1_High1, W1_Low1, a_Range ; 

int min, max ;

double  high, low, HH, LH, HL, LL, maxHH, minHH, maxLL, minLL;  
 
int    nHH, nLL, nHL, nLH;

//+------------------------------------------------------------------+

int init()
{
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }  

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          =  "troHHLLl" ;
   ShortName    =  TAG+symbol+iHHLLperiod+myShift  ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
    
    
  
   tHHLLPeriod = TimeFrameToString(iHHLLperiod) ;
   
   
   deinit();
   
   return(0);
  }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
return(0);
}
  
//+------------------------------------------------------------------+
int start()
{

ObDeleteObjectsByPrefix(ShortName);  
 
n       = 10;
j       = 0 ;
    

DateTime  = iTime(symbol,iHHLLperiod,iHHLLend+myShift ) ; 
a_Open    = iOpen(symbol,iHHLLperiod,iHHLLend+myShift );   

maxHH = -1 ;
minHH = 9999999 ;

maxLL = -1 ;
minLL = 9999999 ;
 
for( i = iHHLLstart; i <= iHHLLend; i++ )
{     

   nHH     =  Highest(symbol,iHHLLperiod,MODE_HIGH,i,myShift); 
   nLH     =  Lowest(symbol,iHHLLperiod,MODE_HIGH,i,myShift); 
   
   nLL     =  Lowest(symbol,iHHLLperiod,MODE_LOW,i,myShift);     
   nHL     =  Highest(symbol,iHHLLperiod,MODE_LOW,i,myShift);  
 
   HH     = iHigh(symbol,iHHLLperiod,nHH); 
   LH     = iHigh(symbol,iHHLLperiod,nLH); 
      
   LL     = iLow(symbol,iHHLLperiod,nLL);      
   HL     = iLow(symbol,iHHLLperiod,nHL);  
   
   if( HH > maxHH) { max = i; maxHH = HH ; }
   if( LH < minHH) { min = i; minHH = LH ; }

   if( HL > maxLL) { max = i; maxLL = HL ; }
   if( LL < minLL) { min = i; minLL = LL ; }


} // for


j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(LH ,lbl[j], Line_Color_HHLL , Line_Style , Line_Width, DateTime, tHHLLPeriod + " LH("+min+")"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(HH  ,lbl[j], Line_Color_HHLL , Line_Style , Line_Width, DateTime, tHHLLPeriod + " HH("+max+")"   ) ;


j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(HL ,lbl[j], Line_Color_HHLL , Line_Style , Line_Width, DateTime, tHHLLPeriod + " HL("+min+")"    ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(LL ,lbl[j], Line_Color_HHLL , Line_Style , Line_Width, DateTime, tHHLLPeriod + " LL("+max+")"    ) ;

if(Show.Open)
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(a_Open ,lbl[j], Line_Color_Open , Line_Style , Line_Width, DateTime, tHHLLPeriod + " Open"    ) ;
}

if(Show.ShadeHHLL)
{
        if (ObjectFind(ShortName+"21") != 0)
        ObjectCreate(ShortName+"21", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"21", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"21", OBJPROP_PRICE1, HH);
        ObjectSet(ShortName+"21", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"21", OBJPROP_PRICE2, LH  ); //  
        ObjectSet(ShortName+"21", OBJPROP_COLOR, colorHHLLHighShade);
        ObjectSet(ShortName+"21", OBJPROP_BACK, true);         

        if (ObjectFind(ShortName+"22") != 0)
        ObjectCreate(ShortName+"22", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"22", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"22", OBJPROP_PRICE1, LL);
        ObjectSet(ShortName+"22", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"22", OBJPROP_PRICE2, HL); // 
        ObjectSet(ShortName+"22", OBJPROP_COLOR, colorHHLLLowShade);
        ObjectSet(ShortName+"22", OBJPROP_BACK, true); 
            
} // if(Show.Shade)

return(0);
}
 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, int width, datetime TimeBar, string text)
{

         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);           
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);             
         }
 
 
 
   if(Show.Labels)
   {         
      string Obj0002 = name+"linelbl" ;

      datetime LabelTime = Time[0]+Period()*60*ShiftLabel ;
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, lvl);
         ObjectSetText(Obj0002,text , 8, "Arial", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, lvl);
      } // if 
                 
   } // if   

   if(Show.Boxes)
   {  
     string dName = name+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],lvl);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,Col);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],lvl);
      } 
   } // if    
 
}

//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
/*

Comment(

 "\n" , 
"DailyOpen " , DoubleToStr(a_Open,Digits) , "\n" ,
"HHLL " , DoubleToStr(a_HHLL,Digits) , "\n" , 
"\n" , 
"DailyOpen + HHLL " , DoubleToStr(a_Open + a_HHLL,Digits) , "\n" , 
"a_high " , DoubleToStr(a_high,Digits) , "\n" ,
"a_low " , DoubleToStr(a_low,Digits) , "\n" ,
"DailyOpen - HHLL " , DoubleToStr(a_Open - a_HHLL,Digits) , "\n" , 
"") ; 


 Comment("DateTime= ", TimeToStr(DateTime) ) ;
 
 */