//+------------------------------------------------------------------+
 

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 8
#property indicator_color1 Aqua
#property indicator_color2 Magenta
#property indicator_minimum 0
#property indicator_maximum 4

extern bool   mySound.Alert    = FALSE ;
//extern bool   myComment    = true ;
  
int myBars1 = 30; 
int myBars2 = 60; 
int myBars3 = 90; 


extern color myBarColorUp   = Green;
extern color myBarColorDown = Red;
//extern color TextColor    = White;

int myBarWidth = 0;
int myWingding = 110;// 112

double BUY10[];
double SELL10[];
 
 
//---- indicator buffers
double     MBuffer[];
double     SBuffer[];
double     BUY20[];
double     SELL20[];
double     BUY30[];
double     SELL30[];


string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 
datetime Trigger ;

//---- variables

string tTrade = "" ;   
color tColor    = White;
string tObjName01   ;
int      corner;
int      window; 
string   shortName;
int      win ;  

bool sFirst;

 


double point, pos = 3, pos1 = 2 , pos2 = 1 , ohigh, olow, chigh, clow, high, low;  

 

bool FILLED = false;

 
  

   int  nMin, nMax,  nHH, nLL;
//+------------------------------------------------------------------+
int init()
  {
  
  sFirst = true ;
   
   period       =  Period() ;     
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }    
   
   
   shortName  = "FOUR " +  Symbol() + " " + tChartPeriod ;
   tObjName01 = shortName +  "0" ;


   IndicatorShortName(shortName);  

//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,myBarWidth,myBarColorUp);
   SetIndexArrow(0,myWingding);
   SetIndexBuffer(0,BUY10);

   
   SetIndexStyle(1,DRAW_ARROW,0,myBarWidth,myBarColorDown);
   SetIndexArrow(1,myWingding);
   SetIndexBuffer(1,SELL10);
     

   SetIndexStyle(2,DRAW_ARROW,0,myBarWidth,myBarColorUp);
   SetIndexArrow(2,myWingding);
   SetIndexBuffer(2,BUY20);

   
   SetIndexStyle(3,DRAW_ARROW,0,myBarWidth,myBarColorDown);
   SetIndexArrow(3,myWingding);
   SetIndexBuffer(3,SELL20);


   SetIndexStyle(4,DRAW_ARROW,0,myBarWidth,myBarColorUp);
   SetIndexArrow(4,myWingding);
   SetIndexBuffer(4,BUY30);

   
   SetIndexStyle(5,DRAW_ARROW,0,myBarWidth,myBarColorDown);
   SetIndexArrow(5,myWingding);
   SetIndexBuffer(5,SELL30);   
   IndicatorDigits(0);
   
   
   return(0);
  }
  
//+------------------------------------------------------------------+
int deinit()
  {
 
  Comment("") ;
   return(0);
  }
     
//+------------------------------------------------------------------+
int start()
  {
  
  
  
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   
   if(FILLED) { limit=Bars-counted_bars; }
   else { limit = Bars ; }
   


   for(int i=0; i<limit; i++)
   {
      SELL10[i]=EMPTY_VALUE;
      BUY10[i]  =EMPTY_VALUE; 
      BUY20[i]  =EMPTY_VALUE;
      SELL20[i]  =EMPTY_VALUE; 
      BUY30[i]  =EMPTY_VALUE;
      SELL30[i]  =EMPTY_VALUE; 

 
      DoWork( myBars1, i ) ;
 
      if ( Close[i] == low ) { BUY10[i] = pos ; }
      else 
      if ( Close[i] == high ) { SELL10[i] = pos ; }
       

      DoWork( myBars2, i ) ;
 
      if ( Close[i] == low ) { BUY20[i] = pos1 ; }
      else 
      if ( Close[i] == high ) { SELL20[i] = pos1 ; }       

      DoWork( myBars3, i ) ;
 
      if ( Close[i] == low ) { BUY30[i] = pos2 ; }
      else 
      if ( Close[i] == high ) { SELL30[i] = pos2 ; }             
   }

   if( i > 100 ) { FILLED = true ; }

  if (  Trigger != Time[0] && mySound.Alert ) // Trigger != Time[0] && 
  {
        if( BUY10[1]  == pos ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " 1 BUY!  "+ DoubleToStr(Close[0] ,digits)); }
        if( SELL10[1] == pos ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " 1 SELL SHORT! "+ DoubleToStr(Close[0] ,digits)); }     
  
        if( BUY20[1]  == pos1 ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " 2 BUY!  "+ DoubleToStr(Close[0] ,digits)); }
        if( SELL20[1] == pos1 ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " 2 SELL SHORT! "+ DoubleToStr(Close[0] ,digits)); }     

        if( BUY30[1]  == pos1 ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " 3 BUY!  "+ DoubleToStr(Close[0] ,digits)); }
        if( SELL30[1] == pos1 ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " 3 SELL SHORT! "+ DoubleToStr(Close[0] ,digits)); }     
    
  }



return(0);
}
//+------------------------------------------------------------------+
  
void DoWork( int wBars, int w )
{
 

nHH     =  Highest(symbol,period,MODE_OPEN,wBars,w); 
nLL     =  Lowest(symbol,period,MODE_OPEN,wBars,w);  
 
ohigh    = iOpen(symbol,period,nHH); 
olow     = iOpen(symbol,period,nLL);
      
 
 
nHH     =  Highest(symbol,period,MODE_CLOSE,wBars,w); 
nLL     =  Lowest(symbol,period,MODE_CLOSE,wBars,w);  
 
chigh    = iClose(symbol,period,nHH); 
clow     = iClose(symbol,period,nLL);

high = MathMax(ohigh,chigh);
low  = MathMin(olow,clow); 
  
 
} 
  
//+------------------------------------------------------------------+
 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+
/*

Comment(

"pair " , symbol , "\n" , 
"MBuffer[0] " , DoubleToStr(MBuffer[0],6) , "\n" ,
"SBuffer[0] " , DoubleToStr(SBuffer[0],6) , "\n" ,

"BUY10[0] " , DoubleToStr(BUY10[0],Digits) , "\n" ,
"BUY10[1] " , DoubleToStr(BUY10[1],Digits) , "\n" ,
"BUY10[2] " , DoubleToStr(BUY10[1],Digits) , "\n" ,
"SELL10[0] " , DoubleToStr(SELL10[0],Digits) , "\n" ,
"SELL10[1] " , DoubleToStr(SELL10[1],Digits) , "\n" ,
"SELL10[2] " , DoubleToStr(SELL10[1],Digits) , "\n" ,
"") ; 




if(myComment)
{
D1_Open  = iOpen(symbol,PERIOD_D1,0);  
D1_Close = iClose(symbol,PERIOD_D1,0);  
D1_high  = iHigh(symbol,PERIOD_D1,0);
D1_low   = iLow(symbol,PERIOD_D1,0);
D1_pivot = ( D1_Close + D1_high + D1_low ) / 3.0 ; 
D1_range = ( D1_high - D1_low ) / point ;
D1_ClOp  = ( D1_Close - D1_Open ) / point ;


Comment(

 "\n" , "Daily " ,  
"O=" , DoubleToStr(D1_Open,Digits) , " " ,
"H=" , DoubleToStr(D1_high,Digits) , " " ,
"L=" , DoubleToStr(D1_low,Digits) , " " ,
"C=" , DoubleToStr(D1_Close,Digits) , " " ,
"P=" , DoubleToStr(D1_pivot,Digits) , " " ,
"R=" , DoubleToStr(D1_range,0) , " " ,
"D=" , DoubleToStr(D1_ClOp,0) , " " ,

"") ; 
} // if(myComment)


*/